/* functions for passing structs between server and client */

#include "bg_mesg.h"

char* base_en = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+?";
char  base_de[] =
  { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, -1,
    52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, 64, -1, 63,
    -1,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
    15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1,
    -1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
    41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
    -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 };
    
char  encoded[8192]; // has extra byte at end for null
char  decoded[6144]; // has extra byte at end for null

int
encode(char* ptr, int size, char* store, int ssize) {
  char* current;
  int   state = 0;
  int   i, j, c, p;

  if (store == 0) {
    store = encoded;
    ssize = sizeof(encoded);
  }
  memset(store, 0, ssize);
  
  i = (ssize/4)*3;
  j = 0; // index into encoded string
  
  if ((size < 0) || (size > i)) {
    return -1;
  }
  for (i=0; i < size; i++) {
    state++;
    c = ptr[i];
    switch (state) {
    case 1: store[j++] = base_en[((c>>2) & 0x3f)]; break;
    case 2: store[j++] = base_en[((p<<4) & 0x30) | ((c>>4) & 0x0f)]; break;
    case 3: 
      store[j++] = base_en[(((p<<2) & 0x3C) | (((c>>6) & 0x3)))];
      store[j++] = base_en[(c & 0x3f)];
      state = 0;
      break;
    };
    p = c; // save last char
  }
  switch (state) {
  case 0: break;
  case 1: 
    store[j++] = base_en[(p<<4) & 0x30];
    store[j++] = '='; encoded[j++] = '='; break;
  case 2:
    store[j++] = base_en[(p<<2) & 0x3c];
    store[j++] = '='; break;
  }
  return j;
}

int
decode(char* ptr, int size) {
  int i,j,g,v;
  unsigned int hold;

  memset(decoded, 0, sizeof(decoded));
  g = 18;
  j = 0;
  hold = 0;
  for (i=0; i < size; i++) {
    v = base_de[ptr[i]];
    if (v >= 0) {
      if (v != 64) {
        hold = (hold | (v << g));
      }
    } else {
      return v; // illegal base64 character
    }
    g -= 6;
    if (g < 0) {
      decoded[j++] = ((hold & 0xff0000) >> 16);
      decoded[j++] = ((hold & 0xff00) >> 8);
      decoded[j++] = (hold & 0xff);
      hold = 0;
      g = 18;
    }
  }
  return j;
}

//#define __TEST_ME__cmdline
#ifdef __TEST_ME__cmdline
int main(int argc, char* argv[]) {
  int i;
  int err;
  
  for (i=1; i < argc; i++) {
    err = encode(argv[i], strlen(argv[i]));
    if (err < 0) {
      printf("couldn't encode string\n");
      exit(0);
    }
    err = decode(encoded, err);
    printf("%s\n%s\n%s\n", argv[i], encoded, decoded);
  }

  // decode error check
  err = decode("ABCDEF90-=[]", 12);
  if (err < 0) {
    printf("error properly detected in decode\n");
  }
}
#endif
